Poj3041-Asteroids-【二分图】

来源:互联网 发布:股票数据挖掘 编辑:程序博客网 时间:2024/06/17 01:22

传送门:http://poj.org/problem?id=3041


Asteroids
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 23470 Accepted: 12737

Description

Bessie wants to navigate her spaceship through a dangerous asteroid field in the shape of an N x N grid (1 <= N <= 500). The grid contains K asteroids (1 <= K <= 10,000), which are conveniently located at the lattice points of the grid. 

Fortunately, Bessie has a powerful weapon that can vaporize all the asteroids in any given row or column of the grid with a single shot.This weapon is quite expensive, so she wishes to use it sparingly.Given the location of all the asteroids in the field, find the minimum number of shots Bessie needs to fire to eliminate all of the asteroids.

Input

* Line 1: Two integers N and K, separated by a single space. 
* Lines 2..K+1: Each line contains two space-separated integers R and C (1 <= R, C <= N) denoting the row and column coordinates of an asteroid, respectively.

Output

* Line 1: The integer representing the minimum number of times Bessie must shoot.

Sample Input

3 41 11 32 23 2

Sample Output

2

Hint

INPUT DETAILS: 
The following diagram represents the data, where "X" is an asteroid and "." is empty space: 
X.X 
.X. 
.X.
 

OUTPUT DETAILS: 
Bessie may fire across row 1 to destroy the asteroids at (1,1) and (1,3), and then she may fire down column 2 to destroy the asteroids at (2,2) and (3,2).

Source

USACO 2005 November Gold

题意:给出n行n列  在上面放小行星,,一发子弹可以打穿一行或一列;求最少的子弹数

解题:把行和列看成二分图的男女  有小行星说明有匹配  求最小子弹数就是求最小顶点覆盖数  

            因为一个顶点连接多的边,意味着连接的点多,,,就可以一发子弹打的点多

           所以就是 求最少顶点覆盖数


所谓最少顶点覆盖数:就等于最大匹配数,,虽然解释上面不一样,但是结果都一样,,,算了不解释了


贴一个会长的vector吧有时间好好用用vector  体会体会

#include <cstdio>#include <stack>#include <queue>#include <cmath>#include <vector>#include <cstring>#include <algorithm>using namespace std;#define CLR(a,b) memset(a,b,sizeof(a))#define INF 0x3f3f3f3f#define LL long longbool vis[500+5];int f[500+5];vector<int> mapp[500+5];bool find(int x){for (int i = 0 ; i < mapp[x].size() ; i++){int y = mapp[x][i];if (vis[y])continue;//搜过的不用再搜 vis[y] = true;if (f[y] == -1)//没有匹配{f[y] = x;return true;}else if (find(f[y])){f[y] = x;return true;}}return false;}int main(){int n,m;CLR(f,-1);scanf ("%d %d",&n,&m);while (m--){int x,y;scanf ("%d %d",&x,&y);mapp[x].push_back(y);}int ant = 0;//最大匹配 for (int i = 1 ; i <= n ; i++){CLR(vis,false);if (find(i))ant++;}printf ("%d\n",ant);//最大匹配即为最小点覆盖 return 0;}


原创粉丝点击